/* ****************************************************************************
**
**		KeyReq / Sound Junkie
**		soundmessage.h
**		Shared Header File for KeyReq (copyright by Georg Steger) and
**		Sound Junkie (copyright by George Hornmoen).
**
**		Georg Steger / George Hornmoen
**
**		Sound Junkie is a 'daemon' process which plays uncompressed IFF
**		sound samples when messaged by the program "KeyReq"
**		(copyright 1997 by Georg Steger).
**
** *****************************************************************************/

/* Message Types */

#define SND_PLAY		101
#define SND_LOAD		102
#define SND_RESCAN		103
#define SND_QUIT		104
#define SND_TEST		105

struct SoundMessage {

	struct Message ExecMessage;

	BYTE messageType;	/* Either SND_PLAY, SND_LOAD, SND_RESCAN, or SND_QUIT */
	BYTE numGadgets;	/* Number of gadgets in the requester */
	LONG sampleID;		/* Used by SND_TEST, and maybe by other programs at a
						   later date */

/* *** The following fields should be NULL if messageType != SND_PLAY *** */

	char *taskName;		/* Task that is opening the requester, currently not used */
	UBYTE *requestBody;	/* Body of the requester [parsed to ID certain types
						   of messages] */
	APTR requestArgs;	/* Args for requestBody - to be used with RawDoFmt */

/* *** Reserved for future expansion *** */

	LONG flags;
	BYTE reserved;
	BYTE expansion;
};


